blob: 7d218f1d614038d727229405bdebc8ba57a8cec0 [file] [log] [blame]
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +01001#!/bin/bash
2#
3# Runner for an individual run-test.
4
5msg() {
6 if [ "$QUIET" = "n" ]; then
7 echo "$@"
8 fi
9}
10
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000011ANDROID_ROOT="/system"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010012ARCHITECTURES_32="(arm|x86|mips|none)"
Andreas Gampe1a5c4062015-01-15 12:10:47 -080013ARCHITECTURES_64="(arm64|x86_64|mips64|none)"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010014ARCHITECTURES_PATTERN="${ARCHITECTURES_32}"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000015BOOT_IMAGE=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010016COMPILE_FLAGS=""
17DALVIKVM="dalvikvm32"
18DEBUGGER="n"
19DEV_MODE="n"
20DEX2OAT=""
Alex Light8a0e0332015-10-26 10:11:58 -070021EXPERIMENTAL=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010022FALSE_BIN="/system/bin/false"
23FLAGS=""
Alex Light7233c7e2016-07-28 10:07:45 -070024ANDROID_FLAGS=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010025GDB=""
Nicolas Geoffraybaf91022014-10-08 09:56:45 +010026GDB_ARGS=""
27GDB_SERVER="gdbserver"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010028HAVE_IMAGE="y"
29HOST="n"
30INTERPRETER="n"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -080031JIT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010032INVOKE_WITH=""
Alex Lighte06b6342017-01-05 14:37:21 -080033IS_JVMTI_TEST="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010034ISA=x86
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000035LIBRARY_DIRECTORY="lib"
Colin Crossafd3c9e2016-09-16 13:47:21 -070036TEST_DIRECTORY="nativetest"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000037MAIN=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010038OPTIMIZE="y"
39PATCHOAT=""
40PREBUILD="y"
41QUIET="n"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +000042RELOCATE="n"
Richard Uhler76f5cb62016-04-04 13:30:16 -070043STRIP_DEX="n"
Jeff Hao207a37d2014-10-29 17:24:25 -070044SECONDARY_DEX=""
Hiroshi Yamauchi6ffb9cc2015-08-31 15:14:17 -070045TIME_OUT="gdb" # "n" (disabled), "timeout" (use timeout), "gdb" (use gdb)
46# Value in seconds
Hiroshi Yamauchifd3161a2017-01-18 14:47:25 -080047if [ "$ART_USE_READ_BARRIER" != "false" ]; then
Hiroshi Yamauchia9b296c2016-10-07 17:07:03 -070048 TIME_OUT_VALUE=2400 # 40 minutes.
Hiroshi Yamauchidcf0d4b2015-09-09 18:59:42 -070049else
Mathieu Chartier2576be22016-05-24 10:24:53 -070050 TIME_OUT_VALUE=1200 # 20 minutes.
Hiroshi Yamauchidcf0d4b2015-09-09 18:59:42 -070051fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010052USE_GDB="n"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +010053USE_JVM="n"
Igor Murashkin7617abd2015-07-10 18:27:47 -070054VERIFY="y" # y=yes,n=no,s=softfail
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010055ZYGOTE=""
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -070056DEX_VERIFY=""
Andreas Gampe65357032015-02-19 15:10:24 -080057USE_DEX2OAT_AND_PATCHOAT="y"
Andreas Gampe4d2ef332015-08-05 09:24:45 -070058INSTRUCTION_SET_FEATURES=""
Mathieu Chartier031768a2015-08-27 10:25:02 -070059ARGS=""
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -070060EXTERNAL_LOG_TAGS="n" # if y respect externally set ANDROID_LOG_TAGS.
61DRY_RUN="n" # if y prepare to run the test but don't run it.
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +000062TEST_VDEX="n"
Alex Lighte06b6342017-01-05 14:37:21 -080063TEST_IS_NDEBUG="n"
Calin Juravle857f0582016-12-20 14:36:59 +000064APP_IMAGE="y"
Nicolas Geoffray74981052017-01-16 17:54:09 +000065VDEX_FILTER=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010066
Igor Murashkin271a0f82017-02-14 21:14:17 +000067# if "y", run 'sync' before dalvikvm to make sure all files from
68# build step (e.g. dex2oat) were finished writing.
69SYNC_BEFORE_RUN="n"
70
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010071while true; do
72 if [ "x$1" = "x--quiet" ]; then
73 QUIET="y"
74 shift
Alex Lighte06b6342017-01-05 14:37:21 -080075 elif [ "x$1" = "x--jvmti" ]; then
76 IS_JVMTI_TEST="y"
77 shift
Alex Lightfaf90b62016-08-12 14:43:48 -070078 elif [ "x$1" = "x-O" ]; then
Alex Lighte06b6342017-01-05 14:37:21 -080079 TEST_IS_NDEBUG="y"
Alex Lightfaf90b62016-08-12 14:43:48 -070080 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010081 elif [ "x$1" = "x--lib" ]; then
82 shift
83 if [ "x$1" = "x" ]; then
84 echo "$0 missing argument to --lib" 1>&2
85 exit 1
86 fi
87 LIB="$1"
88 shift
Alex Light97acf192016-03-17 09:59:38 -070089 elif [ "x$1" = "x--gc-stress" ]; then
90 # Give an extra 5 mins if we are gc-stress.
91 TIME_OUT_VALUE=$((${TIME_OUT_VALUE} + 300))
92 shift
Mathieu Chartier031768a2015-08-27 10:25:02 -070093 elif [ "x$1" = "x--testlib" ]; then
94 shift
95 if [ "x$1" = "x" ]; then
96 echo "$0 missing argument to --testlib" 1>&2
97 exit 1
98 fi
Mathieu Chartierde286fd2015-09-03 18:10:29 -070099 ARGS="${ARGS} $1"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700100 shift
David Srbecky52886112016-01-22 13:56:47 +0000101 elif [ "x$1" = "x--args" ]; then
102 shift
103 if [ "x$1" = "x" ]; then
104 echo "$0 missing argument to --args" 1>&2
105 exit 1
106 fi
107 ARGS="${ARGS} $1"
108 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100109 elif [ "x$1" = "x-Xcompiler-option" ]; then
110 shift
111 option="$1"
112 FLAGS="${FLAGS} -Xcompiler-option $option"
113 COMPILE_FLAGS="${COMPILE_FLAGS} $option"
114 shift
Alex Light7233c7e2016-07-28 10:07:45 -0700115 elif [ "x$1" = "x--android-runtime-option" ]; then
116 shift
117 option="$1"
118 ANDROID_FLAGS="${ANDROID_FLAGS} $option"
119 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100120 elif [ "x$1" = "x--runtime-option" ]; then
121 shift
122 option="$1"
123 FLAGS="${FLAGS} $option"
124 shift
125 elif [ "x$1" = "x--boot" ]; then
126 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000127 BOOT_IMAGE="$1"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100128 shift
129 elif [ "x$1" = "x--no-dex2oat" ]; then
130 DEX2OAT="-Xcompiler:${FALSE_BIN}"
Andreas Gampe65357032015-02-19 15:10:24 -0800131 USE_DEX2OAT_AND_PATCHOAT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100132 shift
133 elif [ "x$1" = "x--no-patchoat" ]; then
134 PATCHOAT="-Xpatchoat:${FALSE_BIN}"
Andreas Gampe65357032015-02-19 15:10:24 -0800135 USE_DEX2OAT_AND_PATCHOAT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100136 shift
137 elif [ "x$1" = "x--relocate" ]; then
138 RELOCATE="y"
139 shift
140 elif [ "x$1" = "x--no-relocate" ]; then
141 RELOCATE="n"
142 shift
143 elif [ "x$1" = "x--prebuild" ]; then
144 PREBUILD="y"
145 shift
Calin Juravle857f0582016-12-20 14:36:59 +0000146 elif [ "x$1" = "x--no-app-image" ]; then
147 APP_IMAGE="n"
148 shift
Richard Uhler76f5cb62016-04-04 13:30:16 -0700149 elif [ "x$1" = "x--strip-dex" ]; then
150 STRIP_DEX="y"
151 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100152 elif [ "x$1" = "x--host" ]; then
153 HOST="y"
Nicolas Geoffray8eedb472014-10-29 14:05:59 +0000154 ANDROID_ROOT="$ANDROID_HOST_OUT"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100155 shift
156 elif [ "x$1" = "x--no-prebuild" ]; then
157 PREBUILD="n"
158 shift
159 elif [ "x$1" = "x--no-image" ]; then
160 HAVE_IMAGE="n"
161 shift
Jeff Hao207a37d2014-10-29 17:24:25 -0700162 elif [ "x$1" = "x--secondary" ]; then
163 SECONDARY_DEX=":$DEX_LOCATION/$TEST_NAME-ex.jar"
Calin Juravle175dc732015-08-25 15:42:32 +0100164 # Enable cfg-append to make sure we get the dump for both dex files.
165 # (otherwise the runtime compilation of the secondary dex will overwrite
Roland Levillainb0103ca2016-11-01 14:48:47 +0000166 # the dump of the first one).
Calin Juravle175dc732015-08-25 15:42:32 +0100167 FLAGS="${FLAGS} -Xcompiler-option --dump-cfg-append"
168 COMPILE_FLAGS="${COMPILE_FLAGS} --dump-cfg-append"
Jeff Hao207a37d2014-10-29 17:24:25 -0700169 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100170 elif [ "x$1" = "x--debug" ]; then
171 DEBUGGER="y"
Brian Carlstrom93d6ce52014-11-04 22:31:35 -0800172 TIME_OUT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100173 shift
174 elif [ "x$1" = "x--gdb" ]; then
175 USE_GDB="y"
176 DEV_MODE="y"
Brian Carlstrom93d6ce52014-11-04 22:31:35 -0800177 TIME_OUT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100178 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700179 elif [ "x$1" = "x--gdb-arg" ]; then
180 shift
181 gdb_arg="$1"
182 GDB_ARGS="${GDB_ARGS} $gdb_arg"
183 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100184 elif [ "x$1" = "x--zygote" ]; then
185 ZYGOTE="-Xzygote"
186 msg "Spawning from zygote"
187 shift
188 elif [ "x$1" = "x--dev" ]; then
189 DEV_MODE="y"
190 shift
191 elif [ "x$1" = "x--interpreter" ]; then
192 INTERPRETER="y"
193 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800194 elif [ "x$1" = "x--jit" ]; then
195 JIT="y"
196 shift
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100197 elif [ "x$1" = "x--jvm" ]; then
198 USE_JVM="y"
199 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100200 elif [ "x$1" = "x--invoke-with" ]; then
201 shift
202 if [ "x$1" = "x" ]; then
203 echo "$0 missing argument to --invoke-with" 1>&2
204 exit 1
205 fi
206 if [ "x$INVOKE_WITH" = "x" ]; then
207 INVOKE_WITH="$1"
208 else
209 INVOKE_WITH="$INVOKE_WITH $1"
210 fi
211 shift
212 elif [ "x$1" = "x--no-verify" ]; then
213 VERIFY="n"
214 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700215 elif [ "x$1" = "x--verify-soft-fail" ]; then
216 VERIFY="s"
217 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100218 elif [ "x$1" = "x--no-optimize" ]; then
219 OPTIMIZE="n"
220 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000221 elif [ "x$1" = "x--android-root" ]; then
222 shift
223 ANDROID_ROOT="$1"
224 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700225 elif [ "x$1" = "x--instruction-set-features" ]; then
226 shift
227 INSTRUCTION_SET_FEATURES="$1"
228 shift
Mathieu Chartier2576be22016-05-24 10:24:53 -0700229 elif [ "x$1" = "x--timeout" ]; then
230 shift
231 TIME_OUT_VALUE="$1"
232 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100233 elif [ "x$1" = "x--" ]; then
234 shift
235 break
236 elif [ "x$1" = "x--64" ]; then
237 ISA="x86_64"
238 GDB_SERVER="gdbserver64"
239 DALVIKVM="dalvikvm64"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000240 LIBRARY_DIRECTORY="lib64"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700241 TEST_DIRECTORY="nativetest64"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100242 ARCHITECTURES_PATTERN="${ARCHITECTURES_64}"
243 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700244 elif [ "x$1" = "x--pic-test" ]; then
245 FLAGS="${FLAGS} -Xcompiler-option --compile-pic"
246 COMPILE_FLAGS="${COMPILE_FLAGS} --compile-pic"
247 shift
Alex Light8a0e0332015-10-26 10:11:58 -0700248 elif [ "x$1" = "x--experimental" ]; then
249 if [ "$#" -lt 2 ]; then
250 echo "missing --experimental option" 1>&2
251 exit 1
252 fi
253 EXPERIMENTAL="$EXPERIMENTAL $2"
254 shift 2
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700255 elif [ "x$1" = "x--external-log-tags" ]; then
256 EXTERNAL_LOG_TAGS="y"
257 shift
258 elif [ "x$1" = "x--dry-run" ]; then
259 DRY_RUN="y"
260 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000261 elif [ "x$1" = "x--vdex" ]; then
262 TEST_VDEX="y"
263 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000264 elif [ "x$1" = "x--vdex-filter" ]; then
265 shift
266 option="$1"
267 VDEX_FILTER="--compiler-filter=$option"
268 shift
Igor Murashkin271a0f82017-02-14 21:14:17 +0000269 elif [ "x$1" = "x--sync" ]; then
270 SYNC_BEFORE_RUN="y"
271 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100272 elif expr "x$1" : "x--" >/dev/null 2>&1; then
273 echo "unknown $0 option: $1" 1>&2
274 exit 1
275 else
276 break
277 fi
278done
279
Alex Light8a0e0332015-10-26 10:11:58 -0700280if [ "$USE_JVM" = "n" ]; then
Alex Light7233c7e2016-07-28 10:07:45 -0700281 FLAGS="${FLAGS} ${ANDROID_FLAGS}"
Alex Light8a0e0332015-10-26 10:11:58 -0700282 for feature in ${EXPERIMENTAL}; do
Alex Lightfa022852015-10-28 09:13:20 -0700283 FLAGS="${FLAGS} -Xexperimental:${feature} -Xcompiler-option --runtime-arg -Xcompiler-option -Xexperimental:${feature}"
Alex Light8a0e0332015-10-26 10:11:58 -0700284 COMPILE_FLAGS="${COMPILE_FLAGS} --runtime-arg -Xexperimental:${feature}"
285 done
286fi
287
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100288if [ "x$1" = "x" ] ; then
289 MAIN="Main"
290else
291 MAIN="$1"
Andreas Gampef2fdc732014-06-11 08:20:47 -0700292 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100293fi
294
295if [ "$ZYGOTE" = "" ]; then
296 if [ "$OPTIMIZE" = "y" ]; then
297 if [ "$VERIFY" = "y" ]; then
298 DEX_OPTIMIZE="-Xdexopt:verified"
299 else
300 DEX_OPTIMIZE="-Xdexopt:all"
301 fi
302 msg "Performing optimizations"
303 else
304 DEX_OPTIMIZE="-Xdexopt:none"
305 msg "Skipping optimizations"
306 fi
307
308 if [ "$VERIFY" = "y" ]; then
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100309 JVM_VERIFY_ARG="-Xverify:all"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100310 msg "Performing verification"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700311 elif [ "$VERIFY" = "s" ]; then
312 JVM_VERIFY_ARG="Xverify:all"
313 DEX_VERIFY="-Xverify:softfail"
314 msg "Forcing verification to be soft fail"
315 else # VERIFY = "n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100316 DEX_VERIFY="-Xverify:none"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100317 JVM_VERIFY_ARG="-Xverify:none"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100318 msg "Skipping verification"
319 fi
320fi
321
322msg "------------------------------"
323
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100324if [ "$DEBUGGER" = "y" ]; then
325 # Use this instead for ddms and connect by running 'ddms':
326 # DEBUGGER_OPTS="-agentlib:jdwp=transport=dt_android_adb,server=y,suspend=y"
327 # TODO: add a separate --ddms option?
328
329 PORT=12345
330 msg "Waiting for jdb to connect:"
331 if [ "$HOST" = "n" ]; then
332 msg " adb forward tcp:$PORT tcp:$PORT"
333 fi
334 msg " jdb -attach localhost:$PORT"
335 DEBUGGER_OPTS="-agentlib:jdwp=transport=dt_socket,address=$PORT,server=y,suspend=y"
336fi
337
Alex Lightfba89fe2017-01-12 16:11:02 -0800338if [ "$IS_JVMTI_TEST" = "y" ]; then
339 plugin=libopenjdkjvmtid.so
340 agent=libtiagentd.so
341 lib=tiagentd
342 if [[ "$TEST_IS_NDEBUG" = "y" ]]; then
343 agent=libtiagent.so
344 plugin=libopenjdkjvmti.so
345 lib=tiagent
346 fi
347
348 ARGS="${ARGS} ${lib}"
349 if [[ "$USE_JVM" = "y" ]]; then
350 FLAGS="${FLAGS} -agentpath:${ANDROID_HOST_OUT}/nativetest64/${agent}=${TEST_NAME},jvm"
351 else
352 FLAGS="${FLAGS} -agentpath:${agent}=${TEST_NAME},art"
353 FLAGS="${FLAGS} -Xplugin:${plugin}"
Nicolas Geoffraya0619e22016-12-20 13:57:43 +0000354 FLAGS="${FLAGS} -Xcompiler-option --debuggable"
Alex Lightfba89fe2017-01-12 16:11:02 -0800355 # Always make the compilation be debuggable.
356 COMPILE_FLAGS="${COMPILE_FLAGS} --debuggable"
357 fi
358fi
359
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100360if [ "$USE_JVM" = "y" ]; then
Alex Light9c20a142016-08-23 15:05:12 -0700361 export LD_LIBRARY_PATH=${ANDROID_HOST_OUT}/lib64
Mathieu Chartiera61894d2015-04-23 16:32:54 -0700362 # Xmx is necessary since we don't pass down the ART flags to JVM.
Vladimir Markoc5798bf2016-12-09 10:20:54 +0000363 # We pass the classes2 path whether it's used (src-multidex) or not.
364 cmdline="${JAVA} ${DEBUGGER_OPTS} ${JVM_VERIFY_ARG} -Xmx256m -classpath classes:classes2 ${FLAGS} $MAIN $@ ${ARGS}"
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700365 if [ "$DEV_MODE" = "y" ]; then
366 echo $cmdline
367 fi
368 $cmdline
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100369 exit
370fi
371
372
373if [ "$HAVE_IMAGE" = "n" ]; then
Nicolas Geoffray47e61d52017-01-31 09:13:52 +0000374 # Add 5 minutes to give some time to generate the boot image.
375 TIME_OUT_VALUE=$((${TIME_OUT_VALUE} + 300))
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000376 DALVIKVM_BOOT_OPT="-Ximage:/system/non-existant/core.art"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000377else
378 DALVIKVM_BOOT_OPT="-Ximage:${BOOT_IMAGE}"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100379fi
380
381
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100382if [ "$USE_GDB" = "y" ]; then
383 if [ "$HOST" = "n" ]; then
384 GDB="$GDB_SERVER :5039"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100385 else
386 if [ `uname` = "Darwin" ]; then
387 GDB=lldb
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700388 GDB_ARGS="$GDB_ARGS -- $DALVIKVM"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100389 DALVIKVM=
390 else
391 GDB=gdb
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700392 GDB_ARGS="$GDB_ARGS --args $DALVIKVM"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100393 # Enable for Emacs "M-x gdb" support. TODO: allow extra gdb arguments on command line.
394 # gdbargs="--annotate=3 $gdbargs"
395 fi
396 fi
397fi
398
399if [ "$INTERPRETER" = "y" ]; then
Nicolas Geoffraye722d292015-12-15 11:51:37 +0000400 INT_OPTS="-Xint"
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -0700401 if [ "$VERIFY" = "y" ] ; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700402 INT_OPTS="${INT_OPTS} -Xcompiler-option --compiler-filter=interpret-only"
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -0700403 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=interpret-only"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700404 elif [ "$VERIFY" = "s" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700405 INT_OPTS="${INT_OPTS} -Xcompiler-option --compiler-filter=verify-at-runtime"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700406 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=verify-at-runtime"
407 DEX_VERIFY="${DEX_VERIFY} -Xverify:softfail"
408 else # VERIFY = "n"
Richard Uhlerf4b34872016-04-13 11:03:46 -0700409 INT_OPTS="${INT_OPTS} -Xcompiler-option --compiler-filter=verify-none"
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -0700410 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=verify-none"
411 DEX_VERIFY="${DEX_VERIFY} -Xverify:none"
412 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100413fi
414
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800415if [ "$JIT" = "y" ]; then
Nicolas Geoffraye722d292015-12-15 11:51:37 +0000416 INT_OPTS="-Xusejit:true"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800417 if [ "$VERIFY" = "y" ] ; then
Calin Juravle09665582016-12-20 14:00:48 +0000418 INT_OPTS="${INT_OPTS} -Xcompiler-option --compiler-filter=interpret-only"
419 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=interpret-only"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800420 else
Richard Uhlerf4b34872016-04-13 11:03:46 -0700421 INT_OPTS="${INT_OPTS} -Xcompiler-option --compiler-filter=verify-none"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800422 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=verify-none"
423 DEX_VERIFY="${DEX_VERIFY} -Xverify:none"
424 fi
425fi
426
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100427JNI_OPTS="-Xjnigreflimit:512 -Xcheck:jni"
428
429if [ "$RELOCATE" = "y" ]; then
430 COMPILE_FLAGS="${COMPILE_FLAGS} --include-patch-information --runtime-arg -Xnorelocate"
431 FLAGS="${FLAGS} -Xrelocate -Xcompiler-option --include-patch-information"
432 if [ "$HOST" = "y" ]; then
433 # Run test sets a fairly draconian ulimit that we will likely blow right over
434 # since we are relocating. Get the total size of the /system/framework directory
435 # in 512 byte blocks and set it as the ulimit. This should be more than enough
436 # room.
437 if [ ! `uname` = "Darwin" ]; then # TODO: Darwin doesn't support "du -B..."
Alex Lightd26b7e42016-04-08 09:44:54 -0700438 ulimit -S $(du -c -B512 ${ANDROID_HOST_OUT}/framework 2>/dev/null | tail -1 | cut -f1) || exit 1
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100439 fi
440 fi
441else
442 FLAGS="$FLAGS -Xnorelocate"
443 COMPILE_FLAGS="${COMPILE_FLAGS} --runtime-arg -Xnorelocate"
Mathieu Chartiercae2ed92015-06-09 13:02:50 -0700444 if [ "$HOST" = "y" ]; then
445 # Increase ulimit to 64MB in case we are running hprof test.
446 ulimit -S 64000 || exit 1
447 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100448fi
449
450if [ "$HOST" = "n" ]; then
Nicolas Geoffrayd295bc82016-11-04 13:03:05 +0000451 # Need to be root to query /data/dalvik-cache
452 adb root > /dev/null
453 adb wait-for-device
454 ISA=
455 ISA_adb_invocation=
456 ISA_outcome=
457 # We iterate a few times to workaround an adb issue. b/32655576
458 for i in {1..10}; do
459 ISA_adb_invocation=$(adb shell ls -F /data/dalvik-cache)
460 ISA_outcome=$?
461 ISA=$(echo $ISA_adb_invocation | grep -Ewo "${ARCHITECTURES_PATTERN}")
462 if [ x"$ISA" != "x" ]; then
463 break;
464 fi
465 done
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100466 if [ x"$ISA" = "x" ]; then
467 echo "Unable to determine architecture"
Nicolas Geoffray8f500fa2016-11-03 11:18:48 +0000468 # Print a few things for helping diagnosing the problem.
Nicolas Geoffrayd295bc82016-11-04 13:03:05 +0000469 echo "adb invocation output: $ISA_adb_invocation"
470 echo "adb invocation outcome: $ISA_outcome"
Nicolas Geoffray8f500fa2016-11-03 11:18:48 +0000471 echo $(adb shell ls -F /data/dalvik-cache)
472 echo $(adb shell ls /data/dalvik-cache)
473 echo ${ARCHITECTURES_PATTERN}
474 echo $(adb shell ls -F /data/dalvik-cache | grep -Ewo "${ARCHITECTURES_PATTERN}")
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100475 exit 1
476 fi
477fi
478
Wojciech Staszkiewicze6636532016-09-23 10:59:55 -0700479# Prevent test from silently falling back to interpreter in no-prebuild mode. This happens
480# when DEX_LOCATION path is too long, because vdex/odex filename is constructed by taking
481# full path to dex, stripping leading '/', appending '@classes.vdex' and changing every
482# remaining '/' into '@'.
483if [ "$HOST" = "y" ]; then
484 max_filename_size=$(getconf NAME_MAX $DEX_LOCATION)
485else
486 # There is no getconf on device, fallback to standard value. See NAME_MAX in kernel <linux/limits.h>
487 max_filename_size=255
488fi
489# Compute VDEX_NAME.
490DEX_LOCATION_STRIPPED="${DEX_LOCATION#/}"
491VDEX_NAME="${DEX_LOCATION_STRIPPED//\//@}@$TEST_NAME.jar@classes.vdex"
492if [ ${#VDEX_NAME} -gt $max_filename_size ]; then
493 echo "Dex location path too long."
494 exit 1
495fi
496
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100497dex2oat_cmdline="true"
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000498vdex_cmdline="true"
Alex Lightafb5d192016-05-24 15:57:45 -0700499mkdir_locations="${DEX_LOCATION}/dalvik-cache/$ISA"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700500strip_cmdline="true"
Igor Murashkin271a0f82017-02-14 21:14:17 +0000501sync_cmdline="true"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100502
Jeff Haodcdc85b2015-12-04 14:06:18 -0800503
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100504if [ "$PREBUILD" = "y" ]; then
Alex Lightafb5d192016-05-24 15:57:45 -0700505 mkdir_locations="${mkdir_locations} ${DEX_LOCATION}/oat/$ISA"
Calin Juravle857f0582016-12-20 14:36:59 +0000506 if [ "$APP_IMAGE" = "y" ]; then
507 # Pick a base that will force the app image to get relocated.
508 app_image="--base=0x4000 --app-image-file=$DEX_LOCATION/oat/$ISA/$TEST_NAME.art"
509 fi
510
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000511 dex2oat_cmdline="$INVOKE_WITH $ANDROID_ROOT/bin/dex2oatd \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100512 $COMPILE_FLAGS \
Nicolas Geoffray68e25eb2014-10-29 23:02:11 +0000513 --boot-image=${BOOT_IMAGE} \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100514 --dex-file=$DEX_LOCATION/$TEST_NAME.jar \
Andreas Gampe14759242016-03-23 10:54:21 -0700515 --oat-file=$DEX_LOCATION/oat/$ISA/$TEST_NAME.odex \
Jeff Haodcdc85b2015-12-04 14:06:18 -0800516 ${app_image} \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100517 --instruction-set=$ISA"
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700518 if [ "x$INSTRUCTION_SET_FEATURES" != "x" ] ; then
519 dex2oat_cmdline="${dex2oat_cmdline} --instruction-set-features=${INSTRUCTION_SET_FEATURES}"
520 fi
Andreas Gampe2ea7b702015-08-07 08:07:16 -0700521
522 # Add in a timeout. This is important for testing the compilation/verification time of
523 # pathological cases.
524 # Note: as we don't know how decent targets are (e.g., emulator), only do this on the host for
525 # now. We should try to improve this.
526 # The current value is rather arbitrary. run-tests should compile quickly.
527 if [ "$HOST" != "n" ]; then
528 # Use SIGRTMIN+2 to try to dump threads.
529 # Use -k 1m to SIGKILL it a minute later if it hasn't ended.
530 dex2oat_cmdline="timeout -k 1m -s SIGRTMIN+2 1m ${dex2oat_cmdline}"
531 fi
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000532 if [ "$TEST_VDEX" = "y" ]; then
Nicolas Geoffray74981052017-01-16 17:54:09 +0000533 vdex_cmdline="${dex2oat_cmdline} ${VDEX_FILTER} --input-vdex=$DEX_LOCATION/oat/$ISA/$TEST_NAME.vdex"
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000534 fi
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700535fi
536
Richard Uhler76f5cb62016-04-04 13:30:16 -0700537if [ "$STRIP_DEX" = "y" ]; then
538 strip_cmdline="zip --quiet --delete $DEX_LOCATION/$TEST_NAME.jar classes.dex"
539fi
540
Igor Murashkin271a0f82017-02-14 21:14:17 +0000541if [ "$SYNC_BEFORE_RUN" = "y" ]; then
542 sync_cmdline="sync"
543fi
544
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700545DALVIKVM_ISA_FEATURES_ARGS=""
546if [ "x$INSTRUCTION_SET_FEATURES" != "x" ] ; then
547 DALVIKVM_ISA_FEATURES_ARGS="-Xcompiler-option --instruction-set-features=${INSTRUCTION_SET_FEATURES}"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100548fi
549
Nicolas Geoffrayc5256042015-12-26 19:41:37 +0000550# java.io.tmpdir can only be set at launch time.
551TMP_DIR_OPTION=""
552if [ "$HOST" = "n" ]; then
553 TMP_DIR_OPTION="-Djava.io.tmpdir=/data/local/tmp"
554fi
555
Nicolas Geoffraya73280d2016-02-15 13:05:16 +0000556# We set DumpNativeStackOnSigQuit to false to avoid stressing libunwind.
557# b/27185632
558# b/24664297
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000559dalvikvm_cmdline="$INVOKE_WITH $GDB $ANDROID_ROOT/bin/$DALVIKVM \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100560 $GDB_ARGS \
561 $FLAGS \
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -0700562 $DEX_VERIFY \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100563 -XXlib:$LIB \
564 $PATCHOAT \
565 $DEX2OAT \
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700566 $DALVIKVM_ISA_FEATURES_ARGS \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100567 $ZYGOTE \
568 $JNI_OPTS \
569 $INT_OPTS \
570 $DEBUGGER_OPTS \
571 $DALVIKVM_BOOT_OPT \
Nicolas Geoffrayc5256042015-12-26 19:41:37 +0000572 $TMP_DIR_OPTION \
Nicolas Geoffraya73280d2016-02-15 13:05:16 +0000573 -XX:DumpNativeStackOnSigQuit:false \
Mathieu Chartier031768a2015-08-27 10:25:02 -0700574 -cp $DEX_LOCATION/$TEST_NAME.jar$SECONDARY_DEX $MAIN $ARGS"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100575
Andreas Gampe3ad5d5e2015-02-03 18:26:55 -0800576# Remove whitespace.
577dex2oat_cmdline=$(echo $dex2oat_cmdline)
578dalvikvm_cmdline=$(echo $dalvikvm_cmdline)
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000579vdex_cmdline=$(echo $vdex_cmdline)
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100580
581if [ "$HOST" = "n" ]; then
582 adb root > /dev/null
583 adb wait-for-device
584 if [ "$QUIET" = "n" ]; then
585 adb shell rm -r $DEX_LOCATION
586 adb shell mkdir -p $DEX_LOCATION
587 adb push $TEST_NAME.jar $DEX_LOCATION
588 adb push $TEST_NAME-ex.jar $DEX_LOCATION
589 else
590 adb shell rm -r $DEX_LOCATION >/dev/null 2>&1
591 adb shell mkdir -p $DEX_LOCATION >/dev/null 2>&1
592 adb push $TEST_NAME.jar $DEX_LOCATION >/dev/null 2>&1
593 adb push $TEST_NAME-ex.jar $DEX_LOCATION >/dev/null 2>&1
594 fi
595
Colin Crossafd3c9e2016-09-16 13:47:21 -0700596 LD_LIBRARY_PATH=/data/$TEST_DIRECTORY/art/$ISA
Nicolas Geoffrayeb441dd2014-10-31 15:34:50 +0000597 if [ "$ANDROID_ROOT" != "/system" ]; then
598 # Current default installation is dalvikvm 64bits and dex2oat 32bits,
599 # so we can only use LD_LIBRARY_PATH when testing on a local
600 # installation.
Alex Light7233c7e2016-07-28 10:07:45 -0700601 LD_LIBRARY_PATH=$ANDROID_ROOT/$LIBRARY_DIRECTORY:$LD_LIBRARY_PATH
Nicolas Geoffrayeb441dd2014-10-31 15:34:50 +0000602 fi
603
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800604 # System libraries needed by libarttestd.so
605 PUBLIC_LIBS=libart.so:libartd.so:libc++.so:libbacktrace.so:libbase.so:libnativehelper.so
Dimitry Ivanov90d48f22016-05-05 17:24:28 -0700606
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100607 # Create a script with the command. The command can get longer than the longest
608 # allowed adb command and there is no way to get the exit status from a adb shell
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700609 # command. Dalvik cache is cleaned before running to make subsequent executions
610 # of the script follow the same runtime path.
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100611 cmdline="cd $DEX_LOCATION && \
612 export ANDROID_DATA=$DEX_LOCATION && \
Dimitry Ivanov90d48f22016-05-05 17:24:28 -0700613 export ANDROID_ADDITIONAL_PUBLIC_LIBRARIES=$PUBLIC_LIBS && \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100614 export DEX_LOCATION=$DEX_LOCATION && \
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000615 export ANDROID_ROOT=$ANDROID_ROOT && \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700616 rm -rf ${DEX_LOCATION}/dalvik-cache/ && \
Alex Lightafb5d192016-05-24 15:57:45 -0700617 mkdir -p ${mkdir_locations} && \
Sebastien Hertz7cde48c2015-01-20 16:06:43 +0100618 export LD_LIBRARY_PATH=$LD_LIBRARY_PATH && \
Nicolas Geoffray4f7fdd22015-04-24 11:57:37 +0100619 export PATH=$ANDROID_ROOT/bin:$PATH && \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100620 $dex2oat_cmdline && \
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000621 $vdex_cmdline && \
Richard Uhler76f5cb62016-04-04 13:30:16 -0700622 $strip_cmdline && \
Igor Murashkin271a0f82017-02-14 21:14:17 +0000623 $sync_cmdline && \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100624 $dalvikvm_cmdline"
625
626 cmdfile=$(tempfile -p "cmd-" -s "-$TEST_NAME")
627 echo "$cmdline" > $cmdfile
628
629 if [ "$DEV_MODE" = "y" ]; then
630 echo $cmdline
631 fi
632
633 if [ "$QUIET" = "n" ]; then
634 adb push $cmdfile $DEX_LOCATION/cmdline.sh
635 else
636 adb push $cmdfile $DEX_LOCATION/cmdline.sh > /dev/null 2>&1
637 fi
638
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700639 if [ "$DRY_RUN" != "y" ]; then
640 adb shell sh $DEX_LOCATION/cmdline.sh
641 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100642
643 rm -f $cmdfile
644else
645 export ANDROID_PRINTF_LOG=brief
Andreas Gampea8780822015-03-13 19:51:09 -0700646
647 # By default, and for prebuild dex2oat, we are interested in errors being logged. In dev mode
648 # we want debug messages.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700649 if [ "$EXTERNAL_LOG_TAGS" = "n" ]; then
650 if [ "$DEV_MODE" = "y" ]; then
651 export ANDROID_LOG_TAGS='*:d'
652 else
653 export ANDROID_LOG_TAGS='*:e'
654 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100655 fi
Andreas Gampea8780822015-03-13 19:51:09 -0700656
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100657 export ANDROID_DATA="$DEX_LOCATION"
Nicolas Geoffray8eedb472014-10-29 14:05:59 +0000658 export ANDROID_ROOT="${ANDROID_ROOT}"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700659 export LD_LIBRARY_PATH="${ANDROID_ROOT}/${LIBRARY_DIRECTORY}:${ANDROID_ROOT}/${TEST_DIRECTORY}"
660 export DYLD_LIBRARY_PATH="${ANDROID_ROOT}/${LIBRARY_DIRECTORY}:${ANDROID_ROOT}/${TEST_DIRECTORY}"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100661 export PATH="$PATH:${ANDROID_ROOT}/bin"
662
David Srbeckyc9ede382015-06-20 06:03:53 +0100663 # Temporarily disable address space layout randomization (ASLR).
664 # This is needed on the host so that the linker loads core.oat at the necessary address.
665 export LD_USE_LOAD_BIAS=1
666
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100667 cmdline="$dalvikvm_cmdline"
668
Hiroshi Yamauchi6ffb9cc2015-08-31 15:14:17 -0700669 if [ "$TIME_OUT" = "gdb" ]; then
670 if [ `uname` = "Darwin" ]; then
671 # Fall back to timeout on Mac.
672 TIME_OUT="timeout"
Hiroshi Yamauchic823eff2015-09-01 16:21:35 -0700673 elif [ "$ISA" = "x86" ]; then
674 # prctl call may fail in 32-bit on an older (3.2) 64-bit Linux kernel. Fall back to timeout.
675 TIME_OUT="timeout"
Hiroshi Yamauchi6ffb9cc2015-08-31 15:14:17 -0700676 else
677 # Check if gdb is available.
678 gdb --eval-command="quit" > /dev/null 2>&1
679 if [ $? != 0 ]; then
680 # gdb isn't available. Fall back to timeout.
681 TIME_OUT="timeout"
682 fi
683 fi
684 fi
685
686 if [ "$TIME_OUT" = "timeout" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100687 # Add timeout command if time out is desired.
Andreas Gampe038bb222015-01-13 19:48:14 -0800688 #
Andreas Gampe6fb92562016-08-01 21:53:57 -0700689 # Note: We first send SIGRTMIN+2 (usually 36) to ART, which will induce a full thread dump
690 # before abort. However, dumping threads might deadlock, so we also use the "-k"
691 # option to definitely kill the child.
692 cmdline="timeout -k 120s -s SIGRTMIN+2 ${TIME_OUT_VALUE}s $cmdline"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100693 fi
694
695 if [ "$DEV_MODE" = "y" ]; then
Igor Murashkin271a0f82017-02-14 21:14:17 +0000696 echo "mkdir -p ${mkdir_locations} && $dex2oat_cmdline && $vdex_cmdline && $strip_cmdline && $sync_cmdline && $cmdline"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100697 fi
698
699 cd $ANDROID_BUILD_TOP
700
David Srbecky2e4afe82016-01-27 18:42:06 +0000701 rm -rf ${DEX_LOCATION}/dalvik-cache/
Alex Lightafb5d192016-05-24 15:57:45 -0700702 mkdir -p ${mkdir_locations} || exit 1
Andreas Gampea8780822015-03-13 19:51:09 -0700703 $dex2oat_cmdline || { echo "Dex2oat failed." >&2 ; exit 2; }
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000704 $vdex_cmdline || { echo "Dex2oat failed." >&2 ; exit 2; }
Richard Uhler76f5cb62016-04-04 13:30:16 -0700705 $strip_cmdline || { echo "Strip failed." >&2 ; exit 3; }
Igor Murashkin271a0f82017-02-14 21:14:17 +0000706 $sync_cmdline || { echo "Sync failed." >&2 ; exit 4; }
Andreas Gampea8780822015-03-13 19:51:09 -0700707
708 # For running, we must turn off logging when dex2oat or patchoat are missing. Otherwise we use
709 # the same defaults as for prebuilt: everything when --dev, otherwise errors and above only.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700710 if [ "$EXTERNAL_LOG_TAGS" = "n" ]; then
711 if [ "$DEV_MODE" = "y" ]; then
712 export ANDROID_LOG_TAGS='*:d'
713 elif [ "$USE_DEX2OAT_AND_PATCHOAT" = "n" ]; then
714 # All tests would log the error of failing dex2oat/patchoat. Be silent here and only
715 # log fatal events.
716 export ANDROID_LOG_TAGS='*:s'
717 else
718 # We are interested in LOG(ERROR) output.
719 export ANDROID_LOG_TAGS='*:e'
720 fi
721 fi
722
723 if [ "$DRY_RUN" = "y" ]; then
724 exit 0
Andreas Gampea8780822015-03-13 19:51:09 -0700725 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100726
727 if [ "$USE_GDB" = "y" ]; then
728 # When running under gdb, we cannot do piping and grepping...
Dmitriy Ivanovf57874d2014-10-07 13:43:23 -0700729 $cmdline "$@"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100730 else
Hiroshi Yamauchi6ffb9cc2015-08-31 15:14:17 -0700731 if [ "$TIME_OUT" != "gdb" ]; then
732 trap 'kill -INT -$pid' INT
733 $cmdline "$@" 2>&1 & pid=$!
734 wait $pid
735 # Add extra detail if time out is enabled.
736 if [ ${PIPESTATUS[0]} = 124 ] && [ "$TIME_OUT" = "timeout" ]; then
737 echo -e "\e[91mTEST TIMED OUT!\e[0m" >&2
738 fi
739 else
740 # With a thread dump that uses gdb if a timeout.
741 trap 'kill -INT -$pid' INT
742 $cmdline "$@" 2>&1 & pid=$!
743 # Spawn a watcher process.
744 ( sleep $TIME_OUT_VALUE && \
745 echo "##### Thread dump using gdb on test timeout" && \
746 ( gdb -q -p $pid --eval-command="info thread" --eval-command="thread apply all bt" \
747 --eval-command="call exit(124)" --eval-command=quit || \
748 kill $pid )) 2> /dev/null & watcher=$!
749 wait $pid
750 test_exit_status=$?
751 pkill -P $watcher 2> /dev/null # kill the sleep which will in turn end the watcher as well
752 if [ $test_exit_status = 0 ]; then
753 # The test finished normally.
754 exit 0
755 else
756 # The test failed or timed out.
757 if [ $test_exit_status = 124 ]; then
758 # The test timed out.
759 echo -e "\e[91mTEST TIMED OUT!\e[0m" >&2
760 fi
761 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100762 fi
763 fi
764fi